VERSION 5.00
Begin VB.Form frmTable 
   Caption         =   "Table Mode"
   ClientHeight    =   1890
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3990
   LinkTopic       =   "Form1"
   ScaleHeight     =   1890
   ScaleWidth      =   3990
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtIO 
      Height          =   285
      Left            =   1440
      TabIndex        =   2
      Text            =   "GPIB0::5"
      Top             =   240
      Width           =   1695
   End
   Begin VB.CommandButton cmdTablemode 
      Caption         =   "Go"
      Height          =   615
      Left            =   720
      TabIndex        =   0
      Top             =   840
      Width           =   2055
   End
   Begin VB.Label Label1 
      Caption         =   "IO Address:"
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   240
      Width           =   975
   End
End
Attribute VB_Name = "frmTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
''   Agilent Technologies, Inc. 2007
''
'' You have a royalty-free right to use, modify, reproduce and distribute
'' the Sample Application Files (and/or any modified version) in any way
'' you find useful, provided that you agree that Agilent Technologies has no
'' warranty,  obligations or liability for any Sample Application Files.
''
'' Agilent Technologies provides programming examples for illustration only,
'' This sample program assumes that you are familiar with the programming
'' language being demonstrated and the tools used to create and debug
'' procedures. Agilent Technologies support engineers can help explain the
'' functionality of Agilent Technologies software components and associated
'' commands, but they will not modify these samples to provide added
'' functionality or construct procedures to meet your specific needs.
'' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

'' If you have any questions or comments about this program, please send an e-mail to
'' plsp_support@agilent.com

Private Sub cmdTablemode_Click()
    main_Tablemode
    End
End Sub

' This is a simple program that sets an Agilent E436xA solar array simulator
' in table mode

Sub main_Tablemode()

    Dim IOaddress As String
    Dim ErrString As String
    
    Dim channel As String
    Dim error As String

    'These variables are neccessary to initialize the VISA COM.
    Dim ioMgr As AgilentRMLib.SRMCls
    Dim SAS As VisaComLib.FormattedIO488

    ' Pull the IO address off of the form
    IOaddress = txtIO.Text

    ' Initialize the VISA COM communication
    Set ioMgr = New AgilentRMLib.SRMCls
    Set SAS = New VisaComLib.FormattedIO488
    Set SAS.IO = ioMgr.Open(IOaddress)

    ' This variable can be changed to program any channel in the mainframe
    channel = "(@1)"
    
    SAS.WriteString "*RST"
    SAS.WriteString "*CLS"
    
    ' Define a new table called test
    SAS.WriteString "MEM:TABL:SEL test"
    
    ' Current points for the Table test
    SAS.WriteString "MEM:TABL:CURR 4.8,4.7,4.5,4,3.5,2.5,1,0.5,0.25,0.125"
    
    ' Voltage points for the Table test
    SAS.WriteString "MEM:TABL:VOLT 5,35,45,50,52,54,56,57,58,59"
    
    ' This will copy the table to non-volitile memory
    SAS.WriteString "MEM:COPY:TABL test1"
    
    ' Selects the Table to be output once the unit is in table mode
    SAS.WriteString "CURR:TABL:NAME test," & channel
    
    ' Put the unit into Table mode
    SAS.WriteString "CURR:MODE TABLE," & channel
    
    ' Enable output
    SAS.WriteString "OUTP ON," & channel
    
    ' The following two commands delete the table.  First you deselect the table
    SAS.WriteString "MEM:TABL:SEL"
    
    ' Then you delete it
    SAS.WriteString "MEM:DEL test"
    
    'Check for errors
    SAS.WriteString "SYST:ERR?"
    error = SAS.ReadString
    error = Left(error, Len(error) - 1)
    
    While error <> "+0,""No error"""
        MsgBox "The settings sent resulted in the following error: " & vbCrLf & error & vbCrLf & "Please double check your settings and try again."
        SAS.WriteString "SYST:ERR?"
        error = SAS.ReadString
        error = Left(error, Len(error) - 1)
    Wend
    
    SAS.IO.Close
    
End Sub


